import java.util.ArrayDeque;
import java.util.PriorityQueue;
import java.util.Queue;

/*GHASSAN FAKHER
*GKF01
SECTION 4*/



public class BST<E extends Comparable> {
	public enum TraversalOrder {
		PreOrder,
		InOrder,
		PostOrder, BreadthFirst
	}
	private TreeNode<E> overallRoot;
	
	// Adds the given value to this BST in sorted order.
	public void add(E data) {
		
		overallRoot = add(overallRoot, data);	
	}
	
	private TreeNode<E> add(TreeNode<E> root, E data)
	{
		if(root == null)
			return new TreeNode<E>(data);
		
		else if(root.data.compareTo(data) >= 1)
			root.left = add(root.left, data);
		
		else if(root.data.compareTo(data) < 1)
			root.right = add(root.right, data);
		
		return root;
	}
	
	
	// Removes the given value from this BST, if it exists.
	public void remove(E data) {
		
		overallRoot = remove(overallRoot, data);
	}
	private TreeNode<E> remove(TreeNode<E> root, E data)
	{
		if(root != null)
		{
			if(root.data.compareTo(data) > 0)
			{
				root.left = remove(root.left, data);
			}
			else if(root.data.compareTo(data) < 0)
			{
				root.right = remove(root.right, data);
			}
			else if(root.data.compareTo(data) == 0)
			{
				if(root.left == null && root.right == null)
					return null;
				
				else if(root.left != null && root.right == null)
					return root.left;
				
				else if(root.right != null && root.left == null)
					return root.right;
				
				else
				{
					root.data = getMinValue(root.right);
					root.right = remove(root.right, root.data);
				}
			}
		}
		return root;
	}
	
	private E getMinValue(TreeNode<E> node)
	{
		while(node.left != null)
		{
			node = node.left;
		}
		return node.data;
	}
	
	
	// Returns whether this tree contains the given integer
	public boolean contains(E value) {
		return contains(overallRoot, value);
	}
	private boolean contains(TreeNode<E> root, E data)
	{
		if(root != null)
		{
			if(root.data.compareTo(data) > 0)
				return contains(root.left, data);
			else if(root.data.compareTo(data) < 0)
				return contains(root.right, data);
			else if(root.data.compareTo(data) == 0)
				return true;
		}
		return false;
	}
	public String print(TraversalOrder order)
	{
		String s = "";
		if(order == TraversalOrder.PreOrder)
			s = printPreOrder(overallRoot, s);
		
		else if(order == TraversalOrder.PostOrder)
			s = printPostOrder(overallRoot, s);
		
		else if(order == TraversalOrder.InOrder)
			s = printInOrder(overallRoot, s);
		else if(order == TraversalOrder.BreadthFirst)
			s = printbreadthFirst(s);
		return s;
	}
	public String printbreadthFirst(String s)
	{
		Queue<TreeNode<E>> queue = new ArrayDeque<TreeNode<E>>();
		queue.add(overallRoot);
		return breadthFirst(overallRoot, queue, s);
	}
	
	private String breadthFirst(TreeNode<E> root, Queue<TreeNode<E>> queue, String s)
	{
		if(!queue.isEmpty())
		{
			if(queue.peek().equals(overallRoot))
			{
				queue.remove();
				s += (root.data + " ");
			}
			
			if(root.left != null)
			{
				queue.add(root.left);
				s += (root.left.data + " ");
			}
			if(root.right != null)
			{
				queue.add(root.right);
				s += (root.right.data + " ");
			}
			s = breadthFirst(queue.remove(), queue, s);
		}
		return s;
	}
	
	public String printPreOrder(TreeNode<E> root, String s)
	{
		s = root.data + " " ;
		if(root.left != null)
			s += printPreOrder(root.left, s);
		
		if(root.right != null)
			s += printPreOrder(root.right, s);
		
		return s;
	}
	public String printPostOrder(TreeNode<E> root, String s)
	{
		if(root.left != null)
			s = printPostOrder(root.left, s);
		
		if(root.right != null)
			s = printPostOrder(root.right, s);
		
		s += root.data + " ";
		return s;
	}
	public String printInOrder(TreeNode<E> root, String s)
	{
		if(root.left != null)
			s = printInOrder(root.left, s) + " ";
			
		s += root.data + " ";
			
		if(root.right != null)
			s = printInOrder(root.right, s) + " ";
		
		return s;	
	}
	
	@Override
	public String toString() {
		return print(TraversalOrder.PreOrder);
	}
}
